Index: /trunk/src/calc_field_tps.m
===================================================================
--- /trunk/src/calc_field_tps.m	(revision 580)
+++ /trunk/src/calc_field_tps.m	(revision 581)
@@ -2,5 +2,5 @@
 %'calc_field_tps': defines fields (velocity, vort, div...) from civ data and calculate them with tps interpolation
 %---------------------------------------------------------------------
-% [DataOut,VarAttribute,errormsg]=calc_field_tps(Coord_tps,NbSites,SubRange,FieldVar,Operation,Coord_interp)
+% [DataOut,VarAttribute,errormsg]=calc_field_tps(Coord_tps,NbSites,SubRange,FieldVar,FieldName,Coord_interp)
 %
 % OUTPUT:
@@ -12,8 +12,8 @@
 % SubRange
 % FieldVar
-% Operation: cell array representing the list of operations (eg div, rot..)
+% FieldName: cell array representing the list of operations (eg div, rot..)
 % Coord_interp: coordiantes of sites on which the fields need to be calculated
 
-function [DataOut,VarAttribute,errormsg]=calc_field_tps(Coord_tps,NbSites,SubRange,FieldVar,Operation,Coord_interp)
+function [DataOut,VarAttribute,errormsg]=calc_field_tps(Coord_tps,NbSites,SubRange,FieldVar,FieldName,Coord_interp)
 
 %list of defined scalars to display in menus (in addition to 'ima_cor').
@@ -44,7 +44,7 @@
 check_grid=0;
 check_der=0;
-for ilist=1:length(Operation)
-    OperationType=regexprep(Operation{ilist},'(.+','');
-    switch OperationType
+for ilist=1:length(FieldName)
+    FieldNameType=regexprep(FieldName{ilist},'(.+','');
+    switch FieldNameType
         case 'vec'
             check_grid=1;
@@ -55,9 +55,9 @@
         case {'U','V','norm'}
             check_grid=1;
-            DataOut.(OperationType)=zeros(nb_sites,1);
+            DataOut.(FieldNameType)=zeros(nb_sites,1);
             VarAttribute{1}.Role='scalar';
         case {'curl','div','strain'}
             check_der=1;
-            DataOut.(OperationType)=zeros(nb_sites,1);
+            DataOut.(FieldNameType)=zeros(nb_sites,1);
             VarAttribute{1}.Role='scalar';
     end
@@ -79,7 +79,7 @@
     end
     ListVar={};
-    for ilist=1:length(Operation)
+    for ilist=1:length(FieldName)
         var_count=numel(ListVar);
-        switch Operation{ilist}
+        switch FieldName{ilist}
             case 'vec(U,V)'
                 ListVar=[ListVar {'U', 'V'}];
Index: /trunk/src/check_files.m
===================================================================
--- /trunk/src/check_files.m	(revision 580)
+++ /trunk/src/check_files.m	(revision 581)
@@ -32,4 +32,5 @@
 svn_info.status=[];
 list_fct={...
+    'xmltree';...%function for editing xml files (toolbox outside uvmat)
     'browse_data';...% function for scanning directories in a project/campaign
     'browse_data.fig';...% GUI corresponding to dataview
@@ -101,4 +102,5 @@
     'set_object.m';...%  edit a projection object
     'set_object.fig';...% interface for set_object
+    'set_subdomains';...% sort a set of points defined by scattered coordinates in subdomains, as needed for tps interpolation
     'stra2num';...% transform letters (a, b, A, B,) or numerical strings ('1','2'..) to the corresponding numbers
     'sub_field';...% combine the two input fields,
@@ -106,4 +108,5 @@
     'struct2xml';... transform a matlab structure to a xml tree.
     'tps_coeff';...% calculate the thin plate spline (tps) coefficients
+    'tps_coeff_field';...% calculate the thin plate spline (tps) coefficients with subdomains for a field structure
     'tps_eval';... %calculate the thin plate spline (tps) interpolation at a set of points
     'tps_eval_dxy';...% calculate the derivatives of thin plate spline (tps) interpolation at a set of points (limited to the 2D case)
Index: /trunk/src/civ_matlab.m
===================================================================
--- /trunk/src/civ_matlab.m	(revision 580)
+++ /trunk/src/civ_matlab.m	(revision 581)
@@ -165,7 +165,7 @@
     
     Data.ListGlobalAttribute=[Data.ListGlobalAttribute {'Patch1_Rho','Patch1_Threshold','Patch1_SubDomain'}];
-    Data.Patch1_Rho=Param.Patch1.FieldSmooth;
-    Data.Patch1_Threshold=Param.Patch1.MaxDiff;
-    Data.Patch1_SubDomain=Param.Patch1.SubdomainSize;
+    Data.Patch1_FieldSmooth=Param.Patch1.FieldSmooth;
+    Data.Patch1_MaxDiff=Param.Patch1.MaxDiff;
+    Data.Patch1_SubDomainSize=Param.Patch1.SubDomainSize;
     nbvar=length(Data.ListVarName);
     Data.ListVarName=[Data.ListVarName {'Civ1_U_smooth','Civ1_V_smooth','Civ1_SubRange','Civ1_NbSites','Civ1_Coord_tps','Civ1_U_tps','Civ1_V_tps'}];
@@ -185,5 +185,5 @@
     end
     [Data.Civ1_SubRange,Data.Civ1_NbSites,Data.Civ1_Coord_tps,Data.Civ1_U_tps,Data.Civ1_V_tps,tild,Ures, Vres,tild,FFres]=...
-        filter_tps([Data.Civ1_X(ind_good) Data.Civ1_Y(ind_good)],Data.Civ1_U(ind_good),Data.Civ1_V(ind_good),[],Data.Patch1_SubDomain,Data.Patch1_Rho,Data.Patch1_Threshold);
+        filter_tps([Data.Civ1_X(ind_good) Data.Civ1_Y(ind_good)],Data.Civ1_U(ind_good),Data.Civ1_V(ind_good),[],Data.Patch1_SubDomainSize,Data.Patch1_FieldSmooth,Data.Patch1_MaxDiff);
     Data.Civ1_U_smooth(ind_good)=Ures;
     Data.Civ1_V_smooth(ind_good)=Vres;
@@ -373,7 +373,7 @@
 if isfield (Param,'Patch2')
     Data.ListGlobalAttribute=[Data.ListGlobalAttribute {'Patch2_Rho','Patch2_Threshold','Patch2_SubDomain'}];
-    Data.Patch2_Rho=Param.Patch2.FieldSmooth;
-    Data.Patch2_Threshold=Param.Patch2.MaxDiff;
-    Data.Patch2_SubDomain=Param.Patch2.SubdomainSize;
+    Data.Patch2_FieldSmooth=Param.Patch2.FieldSmooth;
+    Data.Patch2_MaxDiff=Param.Patch2.MaxDiff;
+    Data.Patch2_SubDomainSize=Param.Patch2.SubdomainSize;
     nbvar=length(Data.ListVarName);
     Data.ListVarName=[Data.ListVarName {'Civ2_U_smooth','Civ2_V_smooth','Civ2_SubRange','Civ2_NbSites','Civ2_Coord_tps','Civ2_U_tps','Civ2_V_tps'}];
@@ -394,5 +394,5 @@
     end
     [Data.Civ2_SubRange,Data.Civ2_NbSites,Data.Civ2_Coord_tps,Data.Civ2_U_tps,Data.Civ2_V_tps,tild,Ures, Vres,tild,FFres]=...
-        filter_tps([Data.Civ2_X(ind_good) Data.Civ2_Y(ind_good)],Data.Civ2_U(ind_good),Data.Civ2_V(ind_good),[],Data.Patch2_SubDomain,Data.Patch2_Rho,Data.Patch2_Threshold);
+        filter_tps([Data.Civ2_X(ind_good) Data.Civ2_Y(ind_good)],Data.Civ2_U(ind_good),Data.Civ2_V(ind_good),[],Data.Patch2_SubDomainSize,Data.Patch2_FieldSmooth,Data.Patch2_MaxDiff);
     Data.Civ2_U_smooth(ind_good)=Ures;
     Data.Civ2_V_smooth(ind_good)=Vres;
Index: /trunk/src/filter_tps.m
===================================================================
--- /trunk/src/filter_tps.m	(revision 580)
+++ /trunk/src/filter_tps.m	(revision 581)
@@ -1,12 +1,12 @@
 %'filter_tps': find the thin plate spline coefficients for interpolation-smoothing
 %------------------------------------------------------------------------
-% [SubRange,NbSites,Coord_tps,U_tps,V_tps,W_tps,U_smooth,V_smooth,W_smooth,FF] =filter_tps(Coord,U,V,W,SubDomain,Rho,Threshold)
+% [SubRange,NbCentres,Coord_tps,U_tps,V_tps,W_tps,U_smooth,V_smooth,W_smooth,FF] =filter_tps(Coord,U,V,W,SubDomain,Rho,Threshold)
 %
 % OUTPUT:
 % SubRange(NbCoord,NbSubdomain,2): range (min, max) of the coordiantes x and y respectively, for each subdomain
-% NbSites(NbSubdomain): number of source points for each subdomain
+% NbCentres(NbSubdomain): number of source points for each subdomain
 % FF: false flags
 % U_smooth, V_smooth: filtered velocity components at the positions of the initial data
-% Coord_tps(NbSites,NbCoord,NbSubdomain): positions of the tps centres
+% Coord_tps(NbCentres,NbCoord,NbSubdomain): positions of the tps centres
 % U_tps,V_tps: weight of the tps for each subdomain
 % to get the interpolated field values, use the function calc_field.m
@@ -19,16 +19,15 @@
 % Subdomain: estimated number of data points in each subdomain
 
-function [SubRange,NbSites,Coord_tps,U_tps,V_tps,W_tps,U_smooth,V_smooth,W_smooth,FF] =filter_tps(Coord,U,V,W,SubDomain,Rho,Threshold)
-%subdomain decomposition
+function [SubRange,NbCentres,Coord_tps,U_tps,V_tps,W_tps,U_smooth,V_smooth,W_smooth,FF] =filter_tps(Coord,U,V,W,SubDomain,Rho,Threshold)
+
+%% adjust subdomain decomposition
 warning off
-nbvec=size(Coord,1);
-W_tps=[];%default
-W_smooth=[];
+NbVec=size(Coord,1);
 NbCoord=size(Coord,2);
-NbSubDomain=nbvec/SubDomain;
-MinCoord=min(Coord,[],1);
-MaxCoord=max(Coord,[],1);
+MinCoord=min(Coord,[],1);%lower coordinate bounds
+MaxCoord=max(Coord,[],1);%upper coordinate bounds
 Range=MaxCoord-MinCoord;
 AspectRatio=Range(2)/Range(1);
+NbSubDomain=NbVec/SubDomain;
 NbSubDomainX=max(floor(sqrt(NbSubDomain/AspectRatio)),1);
 NbSubDomainY=max(floor(sqrt(NbSubDomain*AspectRatio)),1);
@@ -41,15 +40,23 @@
 CentreY=reshape(CentreY,1,[]);% Y positions of subdomain centres
 CentreX=reshape(CentreX,1,[]);% X positions of subdomain centres
-rho=Siz(1)*Siz(2)*Rho/1000;%optimum rho increase as the area of the subdomain (division by 10^6 to reach good values with the default GUI input)
-U_tps_sub=zeros(nbvec,NbSubDomain);%default spline
-V_tps_sub=zeros(nbvec,NbSubDomain);%default spline
-Indices_tps=zeros(nbvec,NbSubDomain);%default indices
-U_smooth=zeros(nbvec,1);
-V_smooth=zeros(nbvec,1);
-nb_select=zeros(nbvec,1);
-FF=zeros(nbvec,1);
+
+%% smoothing parameter
+rho=Siz(1)*Siz(2)*Rho/1000;%optimum rho increase as the area of the subdomain (division by 1000 to reach good values with the default GUI input)
+
+%% default output
+SubRange=zeros(NbCoord,2,NbSubDomain);%initialise the positions of subdomains
+NbCentres=zeros(NbSubDomain);%number of interpolated values per subdomain, =0 by default
+Coord_tps=zeros(NbVec,NbCoord,NbSubDomain);% default positions of the tps source= initial positions of the good vectors sorted by subdomain
+U_tps=zeros(NbVec,NbSubDomain);%default spline
+V_tps=zeros(NbVec,NbSubDomain);%default spline
+W_tps=[];%default (2 component case)
+U_smooth=zeros(NbVec,1); % smoothed velocity U at the initial positions
+V_smooth=zeros(NbVec,1);% smoothed velocity V at the initial positions
+W_smooth=[];%default (2 component case)
+FF=zeros(NbVec,1);
+nb_select=zeros(NbVec,1);
 check_empty=zeros(1,NbSubDomain);
-SubRange=zeros(NbCoord,2,NbSubDomain);%initialise the positions of subdomains
-% SubRangy=zeros(NbSubDomain,2);
+
+%% calculate tps coeff in each subdomain
 for isub=1:NbSubDomain
     SubRange(1,:,isub)=[CentreX(isub)-0.55*Siz(1) CentreX(isub)+0.55*Siz(1)];
@@ -57,10 +64,11 @@
     ind_sel_previous=[];
     ind_sel=0;
-    while numel(ind_sel)>numel(ind_sel_previous) %increase the subdomain during four iterations at most
+    %increase iteratively the subdomain if it contains less than SubDomainNbVec/4 source vectors
+    while numel(ind_sel)>numel(ind_sel_previous)
         ind_sel_previous=ind_sel;
         ind_sel=find(Coord(:,1)>=SubRange(1,1,isub) & Coord(:,1)<=SubRange(1,2,isub) & Coord(:,2)>=SubRange(2,1,isub) & Coord(:,2)<=SubRange(2,2,isub));
         % if no vector in the subdomain, skip the subdomain
         if isempty(ind_sel)
-            check_empty(isub)=1;    
+            check_empty(isub)=1;
             U_tps(1,isub)=0;%define U_tps and V_tps by default
             V_tps(1,isub)=0;
@@ -70,5 +78,5 @@
             SubRange(:,1,isub)=SubRange(:,1,isub)-Siz'/4;
             SubRange(:,2,isub)=SubRange(:,2,isub)+Siz'/4;
-        else          
+        else
             [U_smooth_sub,U_tps_sub]=tps_coeff(Coord(ind_sel,:),U(ind_sel),rho);
             [V_smooth_sub,V_tps_sub]=tps_coeff(Coord(ind_sel,:),V(ind_sel),rho);
@@ -78,6 +86,6 @@
             ind_ind_sel=1:numel(ind_sel);%default
             if exist('Threshold','var')
-            FF(ind_sel)=20*(NormDiff>Threshold);%put FF value to 20 to identify the criterium of elimmination
-            ind_ind_sel=find(FF(ind_sel)==0); % select the indices of ind_sel corresponding to the remaining vectors
+                FF(ind_sel)=20*(NormDiff>Threshold);%put FF value to 20 to identify the criterium of elimmination
+                ind_ind_sel=find(FF(ind_sel)==0); % select the indices of ind_sel corresponding to the remaining vectors
             end
             % if no value exceeds threshold, the result is recorded
@@ -85,25 +93,25 @@
                 U_smooth(ind_sel)=U_smooth(ind_sel)+U_smooth_sub;
                 V_smooth(ind_sel)=V_smooth(ind_sel)+V_smooth_sub;
-                NbSites(isub)=numel(ind_sel);
-                Coord_tps(1:NbSites(isub),:,isub)=Coord(ind_sel,:);
-                U_tps(1:NbSites(isub)+3,isub)=U_tps_sub;
-                V_tps(1:NbSites(isub)+3,isub)=V_tps_sub;         
+                NbCentres(isub)=numel(ind_sel);
+                Coord_tps(1:NbCentres(isub),:,isub)=Coord(ind_sel,:);
+                U_tps(1:NbCentres(isub)+3,isub)=U_tps_sub;
+                V_tps(1:NbCentres(isub)+3,isub)=V_tps_sub;
                 nb_select(ind_sel)=nb_select(ind_sel)+1;
                 display('good')
                 break
-            % if too few selected vectors, increase the subrange for next iteration
+                % if too few selected vectors, increase the subrange for next iteration
             elseif numel(ind_ind_sel)<SubDomain/4 && ~isequal( ind_sel,ind_sel_previous);
                 SubRange(:,1,isub)=SubRange(:,1,isub)-Siz'/4;
                 SubRange(:,2,isub)=SubRange(:,2,isub)+Siz'/4;
-            % else interpolation-smoothing is done again with the selected vectors
+                % else interpolation-smoothing is done again with the selected vectors
             else
                 [U_smooth_sub,U_tps_sub]=tps_coeff(Coord(ind_sel(ind_ind_sel),:),U(ind_sel(ind_ind_sel)),rho);
                 [V_smooth_sub,V_tps_sub]=tps_coeff(Coord(ind_sel(ind_ind_sel),:),V(ind_sel(ind_ind_sel)),rho);
                 U_smooth(ind_sel(ind_ind_sel))=U_smooth(ind_sel(ind_ind_sel))+U_smooth_sub;
-                V_smooth(ind_sel(ind_ind_sel))=V_smooth(ind_sel(ind_ind_sel))+V_smooth_sub;   
-                NbSites(isub)=numel(ind_ind_sel);
-                Coord_tps(1:NbSites(isub),:,isub)=Coord(ind_sel(ind_ind_sel),:);
-                U_tps(1:NbSites(isub)+3,isub)=U_tps_sub;
-                V_tps(1:NbSites(isub)+3,isub)=V_tps_sub;
+                V_smooth(ind_sel(ind_ind_sel))=V_smooth(ind_sel(ind_ind_sel))+V_smooth_sub;
+                NbCentres(isub)=numel(ind_ind_sel);
+                Coord_tps(1:NbCentres(isub),:,isub)=Coord(ind_sel(ind_ind_sel),:);
+                U_tps(1:NbCentres(isub)+3,isub)=U_tps_sub;
+                V_tps(1:NbCentres(isub)+3,isub)=V_tps_sub;
                 nb_select(ind_sel(ind_ind_sel))=nb_select(ind_sel(ind_ind_sel))+1;
                 display('good2')
@@ -113,6 +121,7 @@
     end
 end
+
+%% remove empty subdomains
 ind_empty=find(check_empty);
-%remove empty subdomains
 if ~isempty(ind_empty)
     SubRange(:,:,ind_empty)=[];
@@ -121,6 +130,8 @@
     V_tps(:,ind_empty)=[];
 end
-nb_select(nb_select==0)=1;%ones(size(find(nb_select==0)));
-U_smooth=U_smooth./nb_select;
+
+%% final adjustments
+nb_select(nb_select==0)=1;
+U_smooth=U_smooth./nb_select;% take the average at the intersection of several subdomains
 V_smooth=V_smooth./nb_select;
 fill=zeros(NbCoord+1,NbCoord,size(SubRange,3)); %matrix of zeros to complement the matrix Data.Civ1_Coord_tps (conveninent for file storage)
Index: /trunk/src/find_field_cells.m
===================================================================
--- /trunk/src/find_field_cells.m	(revision 580)
+++ /trunk/src/find_field_cells.m	(revision 581)
@@ -1,4 +1,3 @@
-%'find_field_cells': test field structure for input in proj_field and plot_field
-%    group the variables  into 'fields' with common dimensions
+%'find_field_cells': analyse the field structure for input in uvmat functions, grouping the variables  into 'fields' with common coordinates
 %------------------------------------------------------------------------
 % function  [CellInfo,NbDim,errormsg]=find_field_cells(Data)
@@ -9,5 +8,5 @@
 %     .CoordIndex: array of the indices of the variables representing the coordinates (in the order z,y,x)
 %     .CoordSize: array of the nbre of values for each  coordinate in a grid, nbre of points in the unstructured case
-%     .NbSite_tps:
+%     .NbCentres_tps:
 %     .SubRange_tps
 %     .VarIndex: arrays of the variable indices in the field cell
@@ -19,5 +18,5 @@
 %              _vector_x,_y,_z: indices of variables giving the vector components x, y, z
 %              _warnflag: index of warnflag    
-%      .FieldRequest= 'interp_lin', 'interp_tps' indicate whether lin interpolation  or derivatives (tps) is needed to calculate the requested field
+%      .ProjModeRequest= 'interp_lin', 'interp_tps' indicate whether lin interpolation  or derivatives (tps) is needed to calculate the requested field
 %      .FieldName = operation to be performed to finalise the field cell after projection
 %      .SubCheck=0 /1 indicate that the field must be substracted (second  entry in uvmat)
@@ -61,10 +60,10 @@
 
 function [CellInfo,NbDim,errormsg]=find_field_cells(Data)
-
+CellInfo={};
 NbDim=0;
 errormsg='';
 if ~isfield(Data,'ListVarName'), errormsg='the list of variables .ListVarName is missing';return;end
 if ~isfield(Data,'VarDimName'), errormsg='the list of dimensions .VarDimName is missing';return;end
-nbvar=numel(Data.ListVarName);%number of field variables
+nbvar=numel(Data.ListVarName);%number of variables in the field structure
 if ~isequal(numel(Data.VarDimName),nbvar), errormsg='.ListVarName and .VarDimName have unequal length';return;end
 % check the existence of variable data
@@ -86,5 +85,5 @@
 %   'ancillary','image','color','discrete','scalar','coord_tps'};% rmq vector_x_tps and vector_y_tps to be replaced by vector_x and vector_y
 Role=num2cell(blanks(nbvar));%initialize a cell array of nbvar blanks
-FieldRequest=regexprep(Role,' ',''); % fieldRequest set to '' by default
+ProjModeRequest=regexprep(Role,' ',''); % fieldRequest set to '' by default
 FieldName=cell(size(Role)); % fieldRequest set to {} by default
 CheckSub=zeros(size(Role));% =1 for fields to substract
@@ -95,6 +94,6 @@
             Role{ivar}=Data.VarAttribute{ivar}.Role;
         end
-        if isfield(Data.VarAttribute{ivar},'FieldRequest')
-            FieldRequest{ivar}=Data.VarAttribute{ivar}.FieldRequest;
+        if isfield(Data.VarAttribute{ivar},'ProjModeRequest')
+            ProjModeRequest{ivar}=Data.VarAttribute{ivar}.ProjModeRequest;
         end
         if isfield(Data.VarAttribute{ivar},'FieldName')
@@ -162,21 +161,23 @@
 check_coord_tps= strcmp('coord_tps',Role(~check_select));
 ivar_tps=ivar_remain(check_coord_tps);% variable indices corresponding to tps coordinates
+
+% loop on the tps coordinate sets
 for icell_tps=1:numel(ivar_tps)
+    check_cell=zeros(1,nbvar);% =1 for the variables selected in the current cell
+    check_cell(ivar_tps(icell_tps))=1;% mark the coordiante variable as selected
     DimCell=Data.VarDimName{ivar_tps(icell_tps)};% dimension names for the current tps coordinate variable
     icell=numel(CellInfo)+icell_tps; % new field cell index
     CellInfo{icell}.CoordIndex=ivar_tps(icell_tps);% index of the  tps coordinate variable
-    %CellInfo{icell}.VarIndex_subrange_tps=[];
-    %CellInfo{icell}.VarIndex_nbsites_tps=[];
     if numel(DimCell)==3
         VarDimName=Data.VarDimName(~check_select);
         for ivardim=1:numel(VarDimName)
             if strcmp(VarDimName{ivardim},DimCell{3})
-                CellInfo{icell}.NbSite_tps= ivar_remain(ivardim);
-                check_cell(ivar_remain(ivardim))=1;% nbre of sites for each tps subdomain
+                CellInfo{icell}.NbCentres_tps= ivar_remain(ivardim);% nbre of sites for each tps subdomain
+                check_cell(ivar_remain(ivardim))=1;% mark the variable as selected
             elseif strcmp(VarDimName{ivardim}{1},DimCell{2}) && strcmp(VarDimName{ivardim}{3},DimCell{3})
-                CellInfo{icell}.SubRange_tps=ivar_remain(ivardim);
-                check_cell(ivar_remain(ivardim))=1;% subrange definiton for tps
-            elseif strcmp(VarDimName{ivardim}{1},DimCell{1}) && strcmp(VarDimName{ivardim}{2},DimCell{3})
-                check_cell(ivar_remain(ivardim))=1;% variable
+                CellInfo{icell}.SubRange_tps=ivar_remain(ivardim);% subrange definiton for tps
+                check_cell(ivar_remain(ivardim))=1;% mark the variable as selected
+            elseif strcmp(VarDimName{ivardim}{1},DimCell{1}) && strcmp(VarDimName{ivardim}{2},DimCell{3})% variable
+                check_cell(ivar_remain(ivardim))=1;% mark the variable as selected
             end
         end
@@ -222,5 +223,5 @@
     end
 end
-ListCoordIndex=ListCoordIndex(check_coord_select);% list of coordinate variable indices
+ListCoordIndex=ListCoordIndex(check_keep);% list of coordinate variable indices
 ListCoordName=ListCoordName(check_keep);% list of coordinate variable names
 ListDimName=ListDimName(check_keep);% list of coordinate dimension names
@@ -315,6 +316,6 @@
             CellInfo{icell}.(['VarIndex_' Role{ivar}])= ivar;
         end
-        if ~isempty(FieldRequest{ivar})
-            CellInfo{icell}.FieldRequest=FieldRequest{ivar};
+        if ~isempty(ProjModeRequest{ivar})
+            CellInfo{icell}.ProjModeRequest=ProjModeRequest{ivar};
         end
         if ~isempty(FieldName{ivar})
Index: /trunk/src/plot_field.m
===================================================================
--- /trunk/src/plot_field.m	(revision 580)
+++ /trunk/src/plot_field.m	(revision 581)
@@ -249,5 +249,5 @@
 function errormsg=plot_text(FieldData,CellInfo,htext)
 %-------------------------------------------------------------------
-errormsg=[];
+errormsg='';
 txt_cell={};
 Data={};
@@ -1045,5 +1045,7 @@
     
     %decimate by a factor 2 in vector mesh(4 in nbre of vectors)
+    check_decimate=0;
     if isfield(PlotParam.Vectors,'CheckDecimate4') && PlotParam.Vectors.CheckDecimate4
+        check_decimate=1;
         diffy=diff(vec_Y); %difference dy=vec_Y(i+1)-vec_Y(i)
         dy_thresh=max(abs(diffy))/2; 
@@ -1055,4 +1057,17 @@
         nb_sel=length(ind_sel);
         ind_sel=ind_sel(1:2:nb_sel);% take half the points on a line
+    elseif isfield(PlotParam.Vectors,'CheckDecimate16') && PlotParam.Vectors.CheckDecimate16
+        check_decimate=1;
+        diffy=diff(vec_Y); %difference dy=vec_Y(i+1)-vec_Y(i)
+        dy_thresh=max(abs(diffy))/2; 
+        ind_jump=find(abs(diffy) > dy_thresh); %indices with diff(vec_Y)> max/2, detect change of line
+        ind_sel=1:ind_jump(1);%select the first line
+        for i=2:4:length(ind_jump)-1
+            ind_sel=[ind_sel (ind_jump(i)+1:ind_jump(i+1))];% select the odd lines
+        end
+        nb_sel=length(ind_sel);
+        ind_sel=ind_sel(1:4:nb_sel);% take half the points on a line
+    end
+    if check_decimate
         vec_X=vec_X(ind_sel);
         vec_Y=vec_Y(ind_sel);
